;;#0FAF(4015)  Border.  .

;---------------------------------------
; TSConf examples
; (C) breeze/fishbone crew 2013
;---------------------------------------

        DEVICE ZXSPECTRUM128


 org $4000
basb:
 inchob "SD.!b"
base:
		org	#6000-3

VPage		equ	#01AF
VConfig		equ	#00AF

XOffsL		equ	#02AF
XOffsH		equ	#03AF

RAMPage3	equ	#13AF

startCode
 jp dointro
st:incbin"sin2.bin"
dointro:

 ld a,#20
 call cls

; ld a,#28
; call cls

		LD	BC,VConfig    ;  : %01-320x200, %010-256 
		LD	A,%01000010
		;LD	A,%10000010
		OUT	(C),A
;-----------------------------------------
;        ld a,$20
;		LD	BC,VPage      ;  ,     #20
;		OUT	(C),A

 jp dotw
;------------mk palette
;open FMAddr access from 0x0000
FMAddr     EQU #15AF
 ld bc, FMAddr
 ld a, 0x10;0x18 - if $8000
 out (c), a

 ld hl,0
 ld c,0
mkpal:
 push hl
 ld a,c:and $1F
 ld l,a
 ld h,0
 push hl
 
 add hl,hl;*2
 add hl,hl;*4
 add hl,hl;*8
 add hl,hl;*16
 add hl,hl;*32
 push hl
 
 add hl,hl;*2
 add hl,hl;*4
 add hl,hl;*8
 add hl,hl;*16
 add hl,hl;*32

 pop de:add hl,de
 pop de:add hl,de;RGB
 ex de,hl
 pop hl
;load CRAM
;.: gggBBbbb
;.: 0RRrrrGG
 ld (hl),e:inc hl
 ld (hl),d:inc hl
 inc c
 jp nz,mkpal

;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a

;-----------------test plot
dotw:
 ld iy,$5C3A
 ei:halt

memv: ld a,$20;
 LD	BC,VPage      ;  ,     #20/28
 OUT	(C),A

 xor 16:ld (memv+1),a
 ld (pages+2),a
 ld (cp1+1),a
;; ld (cp2+1),a
 call cls

counter: ld a,0
vv0: add a,3;inc a
 ld(counter+1),a;  COUNTER=COUNTER+1
;For Y=0 To 479;255
 ld ixh,0;y
pages: ld ixl,$20
 exx
 ld hl,$C000
 exx

twister:
 ld a,ixl
 LD	BC,RAMPage3   ;   #20   #c000
 OUT	(C),A
 ld h,high st
 ld a,(counter+1),c,a
;     sv=s((y-counter)&255)*2
 ld a,ixh:sub c
 ld l,a
 ld a,(hl)
 add a,a
 ld b,a

;       xx.b=s(255&(cc+y))+s(255&(dd+y))
  ld a,ixh
ccv1: add a,0
 ld l,a
 ld c,(hl)

 ld a,ixh
ddv1: add a,0
 ld l,a
 ld a,c
 add a,(hl)
; sra a
 add a,#50
 exx
 push hl
 ld c,a
 ld b,0
 add hl,bc
 exx;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ld iyh,0
;x1=s((sv+counter)&255)+lCenterX
 ld c,#40
 ld a,(counter+1)
 add a,b;ixl
 ld l,a
; ld e,(hl);x1
 ld a,(hl):add a,h:ld e,a

;    x2=s((sv+counter+64)&255)+lCenterX
 ld a,l:add a,c:ld l,a;;ld a,l:add a,#40:ld l,a
; ld d,(hl);x2
 ld a,(hl):add a,h:ld d,a
 
;    x3=s((sv+counter+128)&255)+lCenterX
 ld a,l:add a,c:ld l,a;;ld a,l:add a,#40:ld l,a
; ld b,(hl);x3
 ld a,(hl):add a,h:ld b,a
 
;    x4=s((sv+counter+192)&255)+lCenterX
 ld a,l:add a,c:ld l,a;;ld a,l:add a,#40:ld l,a
; ld c,(hl);x4
 ld a,(hl):add a,h:ld c,a

; ld a,e:add a,h:ld e,a;ld a,e:add a,#60:ld e,a
; ld a,d:add a,h:ld d,a;ld a,d:add a,#60:ld d,a
; 
; ld a,c:add a,h:ld c,a;ld a,c:add a,#60:ld c,a
; ld a,b:add a,h:ld b,a;ld a,b:add a,#60:ld b,a


;    If X2>X1
;      LineXY(x1,y,x2,y,RGB(SLICE,SLICE*0.5,SLICE*0.2))
;    EndIf
 ld a,d:cp e
 jr nc,test2
;-----------------------------plot here
;b=x3,c=x4,e=x1,d=x2
 push de
 exx
 pop de
 
 ld a,e:cp d;x1>x2?
 jr nc,noswap1
 ld a,e
 ld d,e
 ld d,a
noswap1:
 ;e=source X,d=destination X
 push hl
 ld a,e:sub d
 ld b,a
 ld c,$12
 ld e,d,d,0
 add hl,de
linelp1:ld (hl),c:inc hl:djnz linelp1
 pop hl
 exx
; push hl
; ld b,0
; push hl
; ld c,e
; add hl,bc
; ld (hl),$8
;
; pop hl
; ld c,d
; add hl,bc
; ld (hl),$8
; pop hl
; exx
;    If X3>X2
;        LineXY(x2,y,x3,y,RGB(SLICE*0.5,SLICE*0.2,SLICE))
;    EndIf
test2:
 ld a,b:cp d:jr nc,test3
;b=x3,c=x4,e=x1,d=x2
 push de,bc
 exx
 pop bc,de

 push hl
; ld a,b:cp d;x3>x2?
; jr nc,case21
;from x3 to x2
 ld a,d:sub b
 ld e,b,d,0
 add hl,de
 ld b,a
 ld c,8
linelp21:ld (hl),c:inc hl:djnz linelp21
 jr exitc2
case21:

exitc2:
 pop hl
 exx
; push hl
; ld e,b;x3
; ld b,0
; ld c,iyl
; add hl,bc
; push hl
; ld c,e;x3
; add hl,bc
; ld (hl),8
;
; pop hl
; ld c,d
; add hl,bc
; ld (hl),8
; 
; pop hl
; exx

;    If X4>X3
;        LineXY(x3,y,x4,y,RGB(SLICE*0.2,SLICE,SLICE*0.5))
;    EndIf
test3:;b=x3,c=x4,e=x1,d=x2
 ld a,c:cp b:jr nc,test4
 push bc
 exx
 pop bc
 push hl
 ld e,b
 ld d,c
 ld a,e:cp d;x3>x4?
 jr nc,noswap3
 ld a,e
 ld d,e
 ld d,a
noswap3:
 ;e=source X,d=destination X
 ld a,e:sub d
 ld b,a
 ld c,$14
 ld e,d,d,0
 add hl,de
linelp31:ld (hl),c:inc hl:djnz linelp31
 pop hl
 exx
; ld d,0
; push hl
; ld e,c
; add hl,de
; ld (hl),8
; pop hl
; ld e,b
; add hl,de
; ld (hl),8
; pop hl
; exx

;    If X1>X4
;        LineXY(x4,y,x1,y,RGB(SLICE*0.2,SLICE*0.5,SLICE))
;    EndIf
test4:;b=x3,c=x4,e=x1,d=x2
;; jp test5
 ld a,e:cp c:jr nc,test5
 push de,bc
 exx
 pop bc,de
 push hl
 
 ld a,c:sub e;x4-x1

 ld d,0;,e,c;+x4
 add hl,de
 ld b,a
 ld c,9
linelp41:ld (hl),c:inc hl:djnz linelp41
 pop hl
 exx
; ld b,e;x4
; ld d,0
; 
; ;ld e,iyl
; ;add hl,de
; push hl
; ld e,c
; add hl,de
; ld (hl),8
; pop hl
; ld e,b
; add hl,de
; ld (hl),8
; 
;; ld l,$FF
;; ld (hl),8
;
; pop hl
; exx

test5:
 exx
 pop hl
 inc h,h
 jr nz,nonextp
 inc ixl
 ld h,$C0
nonextp:
 exx
;    Next Y
 inc ixh
 ld a,ixh
ylimit: cp 200
 jp nz,twister

;; jr $
 ld a,(ccv1+1):add a,3:ld (ccv1+1),a
 ld a,(ddv1+1):add a,-1:ld (ddv1+1),a
; call cls
 jp dotw

cls:
DMASAddrL       EQU	#1AAF
DMASAddrH       EQU	#1BAF
DMASAddrX       EQU	#1CAF
DMADAddrL       EQU	#1DAF
DMADAddrH       EQU	#1EAF
DMADAddrX       EQU	#1FAF
DMALen          EQU	#26AF
DMACtrl         EQU	#27AF
DMANum          EQU	#28AF
DMAStatus       EQU	#27AF
Page0           EQU	#10AF
Page1           EQU	#11AF
Page2           EQU	#12AF
Page3           EQU	#13AF

clear_page   ld   bc,Page0   ; 
cp1:      ld   a,$20;;33      ;33
;      out   (c),a      ; 0 
      ld   hl,0      ;  0000
      ld   (0),hl


;      ld   bc,DMASAddrX   ;
;cp2:      ld   a,$20;;33      ; 
;      out   (c),a      ; 
;      ld   hl,0      ; 33 
;      ld   bc,DMASAddrH   ;
;      out   (c),h      ;
;      ld   bc,DMASAddrL   ;
;      out   (c),l      ;
;
;      ld   bc,DMADAddrX   ;
;      ld   a,128      ; 128 
;      out   (c),a      ;
;      ld   hl,0      ; 0  ( )
;      ld   bc,DMADAddrH   ;
;      out   (c),h      ;
;      ld   bc,DMADAddrL   ;
;      out   (c),l      ;
;   
;      ld   bc,DMALen   ;  512  (0-2,255-512)
;      ld   a,255
;      out   (c),a
;   
;      ld   bc,DMANum   ;256 
;      ld   a,255
;      out   (c),a
;   
;      ld   bc,DMACtrl   ; FILL->RAM
;      ld   a,%00000100
;      out   (c),a
;      
;      ld   bc,DMAStatus   ; 
;c1rl      in   a,(c)
;      or   a
;      jr   nz,c1rl
;      ret

    ld bc,#13AF
;;    ld a,#20
    out (c),a
    ld hl,0
    ld (#c000),hl
    ld bc,#20af
    ld a,6 
    out (c),a
    ld bc,#1AAF
    ld a,(memv+1)
    ld h,a
    ld l,0
;    ld hl,#2000
    out (c),l;DMASAddrL       EQU	#1AAF
    inc b
    out (c),l;DMASAddrH       EQU	#1BAF
    inc b
    out (c),h;DMASAddrX       EQU	#1CAF
    inc b
    out (c),l;DMADAddrL       EQU	#1DAF
    inc b
    out (c),l;DMADAddrH       EQU	#1EAF
    inc b
    out (c),h;DMADAddrX       EQU	#1FAF
    ld b,#26
    dec l
;;    ld a,8*8
    out (c),l;DMALen          EQU	#26AF
    inc b
    inc b
    ld a,199;;125+3;;
    out (c),a;;l;DMANum          EQU	#28AF
    dec b
    ld a,%00000100; FILL->RAM
    out (c),a;DMACtrl         EQU	#27AF
waitdma1:
    inf
    jp m,waitdma1
    ld b,#26
    ld a,8*8
    out (c),a;l;DMALen          EQU	#26AF
    inc b
    inc b
    out (c),l;DMANum          EQU	#28AF
    dec b
    ld a,%00000100
    out (c),a
waitdma2:
    inf
    jp m,waitdma2
 ret
endCode:
 display /d,endCode-startCode
;	SAVESNA "sinedots.sna", startCode
    EMPTYTRD "sd.trd"
    SAVETRD "sd.trd","sd.C",startCode,endCode-startCode
    SAVETRD "sd.trd","boot.B",basb,base-basb
